> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create custom object records

POST https://rest.test.zuora.com/objects/records/default/{object}
Content-Type: application/json

Creates custom object records with the given type.

Upon creating records of a custom object type, the 200 response contains a list of records that have been successfully processed and stored.

### Limitations

This call has the following limitations:

* The maximum number of records that you can create by one call is 1,000.
* The storage of empty strings in records is not supported.
* Null values must be formatted as the following example:
  ```
  {
    "records": [
      {
        "fieldName__c": null
      }
    ]
  }
  ```
* When creating or updating custom object records with relationship-type fields, Zuora verifies the related objects against the transactional databases, which are updated in near real-time. The record creation or modification fails upon unsuccessful verifications. If the related objects are newly created in your tenant, it might need some time for the transactional database synchronization.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/custom-objects/custom-object-records/post-custom-object-records

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `object` (string, required) — Specifies the custom object's API name as object. It is case-sensitive.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (date, optional) — API version that determines the response schema. The default version is used if this parameter is not included. Specify `Zuora-Version` in the request header if you expect a specific response schema.

### Body (application/json)

This endpoint expects a PostCustomObjectRecordsRequest.

- `records` (list of CustomObjectRecordWithOnlyCustomFields, required) — A list of custom object records to be created
- `allowPartialSuccess` (boolean, optional, default: false) — Indicates whether the records that pass the schema validation should be created when not all records in the request pass the schema validation.

## Response

### 200

OK The 200 response indicates that the records have been partially or completely created. * If the `allowPartialSuccess` flag is set to `false`, the 200 response indicates that all object records have been successfully created. * If the `allowPartialSuccess` flag is set to `true`, the 200 response indicates that some records might not be succesffully created and the error information might be contained in the response body.

- `error` (CustomObjectRecordsErrorResponse, optional)
- `records` (list of CustomObjectRecordWithAllFields, optional) — The custom object records that are succesfully created and stored

## Errors

### 400 Bad Request Error

Failed schema validation

- `code` (integer, optional)
- `details` (list of CustomObjectRecordsWithError, optional)
- `message` (string, optional)

### 401 Unauthorized Error

Unauthorized

- `code` (integer, optional)
- `details` (list of Error401, optional)
- `message` (string, optional)

### 500 Internal Server Error

Internal error. Retry the returned records.

- `code` (integer, optional)
- `details` (list of CustomObjectRecordsWithError, optional)
- `message` (string, optional)

## Types

### CustomObjectRecordWithOnlyCustomFields

### CustomObjectRecordsErrorResponse

- `code` (integer, optional)
- `details` (list of CustomObjectRecordsWithError, optional)
- `message` (string, optional)

### CustomObjectRecordWithAllFields

Record data from an object

- `CreatedById` (string, optional) — The creator's Id
- `CreatedDate` (datetime, optional) — The record creation time in the date-time format
- `Id` (string, optional) — The unique Id of the custom object record
- `UpdatedById` (string, optional) — The modifier's Id
- `UpdatedDate` (datetime, optional) — The record modification time in the date-time format
- `type` (string, optional) — The type of the custom object record. It is the API name of the custom object definition.

### CustomObjectRecordsWithError

- `code` (enum, optional) — See Custom Objects API error code for details.
  - Allowed values: `71012520`, `71012521`, `71012522`, `71012523`, `71012524`, `71012525`, `71012526`, `71012530`
- `message` (string, optional)
- `record` (CustomObjectRecordWithAllFields, optional) — Record data from an object

### Error401

- `code` (integer, optional)
- `message` (string, optional)

## Examples

### Partial success turned off

**Request**

```json
{
  "records": [
    {
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ]
}
```

**Response**

```json
{
  "records": [
    {
      "CreatedById": "8ad084a67f9c7138017fab8a8b511b5a",
      "CreatedDate": "2024-07-09T06:41:17.377Z",
      "Id": "9ef0b1a0-e398-46aa-856f-76273b0d2988",
      "UpdatedById": "8ad084a67f9c7138017fab8a8b511b5a",
      "UpdatedDate": "2024-07-09T06:41:17.377Z",
      "type": "Vehicle",
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ],
  "unprocessedRecords": []
}
```

**SDK Code**

```python Partial success turned off
import requests

url = "https://rest.test.zuora.com/objects/records/default/object"

payload = { "records": [
        {
            "DeviceId__c": "10101010",
            "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Partial success turned off
const url = 'https://rest.test.zuora.com/objects/records/default/object';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"records":[{"DeviceId__c":"10101010","OrderId__c":"c086028c-5df8-427d-a3c8-7a7fb5d32d3d"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Partial success turned off
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/objects/records/default/object"

	payload := strings.NewReader("{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Partial success turned off
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/objects/records/default/object")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Partial success turned off
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/objects/records/default/object")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ]\n}")
  .asString();
```

```php Partial success turned off
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/objects/records/default/object', [
  'body' => '{
  "records": [
    {
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Partial success turned off
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/objects/records/default/object");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Partial success turned off
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["records": [
    [
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/objects/records/default/object")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Partial success turned on

**Request**

```json
{
  "records": [
    {
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    },
    {
      "DeviceId__c": "10101011",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ],
  "allowPartialSuccess": true
}
```

**Response**

```json
{
  "error": {
    "code": 71012520,
    "details": [
      {
        "code": 71012526,
        "message": "Json input does not match schema. Error: Field [DeviceId__c] should be string type but received integer.",
        "record": {
          "Id": "6d96fbde-213c-43c3-bbef-9b777b050a94",
          "DeviceId__c": "10101011",
          "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
        }
      }
    ],
    "message": "Request contains invalid record that failed validation against the object schema."
  },
  "records": [
    {
      "CreatedById": "8ad084a67f9c7138017fab8a8b511b5a",
      "CreatedDate": "2024-07-09T06:41:17.377Z",
      "Id": "9ef0b1a0-e398-46aa-856f-76273b0d2988",
      "UpdatedById": "8ad084a67f9c7138017fab8a8b511b5a",
      "UpdatedDate": "2024-07-09T06:41:17.377Z",
      "type": "Vehicle",
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ],
  "unprocessedRecords": []
}
```

**SDK Code**

```python Partial success turned on
import requests

url = "https://rest.test.zuora.com/objects/records/default/object"

payload = {
    "records": [
        {
            "DeviceId__c": "10101010",
            "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
        },
        {
            "DeviceId__c": "10101011",
            "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
        }
    ],
    "allowPartialSuccess": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Partial success turned on
const url = 'https://rest.test.zuora.com/objects/records/default/object';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"records":[{"DeviceId__c":"10101010","OrderId__c":"c086028c-5df8-427d-a3c8-7a7fb5d32d3d"},{"DeviceId__c":"10101011","OrderId__c":"c086028c-5df8-427d-a3c8-7a7fb5d32d3d"}],"allowPartialSuccess":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Partial success turned on
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/objects/records/default/object"

	payload := strings.NewReader("{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    },\n    {\n      \"DeviceId__c\": \"10101011\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ],\n  \"allowPartialSuccess\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Partial success turned on
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/objects/records/default/object")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    },\n    {\n      \"DeviceId__c\": \"10101011\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ],\n  \"allowPartialSuccess\": true\n}"

response = http.request(request)
puts response.read_body
```

```java Partial success turned on
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/objects/records/default/object")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    },\n    {\n      \"DeviceId__c\": \"10101011\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ],\n  \"allowPartialSuccess\": true\n}")
  .asString();
```

```php Partial success turned on
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/objects/records/default/object', [
  'body' => '{
  "records": [
    {
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    },
    {
      "DeviceId__c": "10101011",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    }
  ],
  "allowPartialSuccess": true
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Partial success turned on
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/objects/records/default/object");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"records\": [\n    {\n      \"DeviceId__c\": \"10101010\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    },\n    {\n      \"DeviceId__c\": \"10101011\",\n      \"OrderId__c\": \"c086028c-5df8-427d-a3c8-7a7fb5d32d3d\"\n    }\n  ],\n  \"allowPartialSuccess\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Partial success turned on
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "records": [
    [
      "DeviceId__c": "10101010",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    ],
    [
      "DeviceId__c": "10101011",
      "OrderId__c": "c086028c-5df8-427d-a3c8-7a7fb5d32d3d"
    ]
  ],
  "allowPartialSuccess": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/objects/records/default/object")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```